<?php
################################################################################
### This disclaimer must be kept intact in order to use this product.        ###
################################################################################
### Project: jT CarFramework [http://intersofts.com]
### Author: J. Toshio Taniguchi
### Since: 27.04.2011
### Version: 1.0.0
### Copyrights: J. Toshio Taniguchi
### Contact: j.taniguchi@taniguchi-blog.com
################################################################################
### CONTRIBUTORS
### - none
################################################################################
class admintermsofusepolicy 
{
    protected $lang;
    protected $form_status;
    protected $form_message;
    protected $form_style;
    protected $html;
    
    /*
     * Constructor -------------------------------------------------------------
     */
    public function admintermsofusepolicy($lang=array())
    {
        $this->lang = $lang;
        
        // handle save terms of use form button (save).
        if( isset($_POST['bodyInput']) )
        {
            $this->handleSaveForm();
        }
        
        // load terms of use HTML body.
        $this->loadHTMLBody();
    }
    
    /*
     * Protected method: handle save form --------------------------------------
     * @return void.
     */
    protected function handleSaveForm()
    {
        $html = trim($_POST['bodyInput']);
        $html = stripslashes($html);
        
        // no need validation.
        
        // update terms of use file.
        $path = BASE_ROOT . 'terms-of-use.php';
        
        if( !file_exists($path) )
        {
            require_once BASE_CLASS . 'class-log.php';
            
            LogReport::write('Unable to update terms of use HTML content. File does not exists. Error throw at ' . __FILE__ . ':' . __LINE__);
            
            $this->form_message = $this->lang['TERMS_UPDATE_HTML_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-warning';
            return;
        }
        
        if( !$fo = @fopen($path,'w') )
        {
            require_once BASE_CLASS . 'class-log.php';
            
            LogReport::write('Unable to open (fopen) terms of use HTML content. Access denied at ' . __FILE__ . ':' . __LINE__);
            
            $this->form_message = $this->lang['TERMS_UPDATE_HTML_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-warning';
            return;
        }
        
        if( !@fwrite($fo, $html) )
        {
            @fclose($fo);
            
            require_once BASE_CLASS . 'class-log.php';
            
            LogReport::write('Unable to open (fwrite) terms of use HTML content. Access denied at ' . __FILE__ . ':' . __LINE__);
            
            $this->form_message = $this->lang['TERMS_UPDATE_HTML_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-warning';
            return;
        }
        
        @fclose($fo);
        
        $this->form_message = $this->lang['TERMS_UPDATE_HTML_SUCCESS'];
        $this->form_status = true;
        $this->form_style = 'alert-success';
        return;
    }
    
    /*
     * Protected method: load HTML body ----------------------------------------
     * @return void.
     */
    protected function loadHTMLBody()
    {
        $path = BASE_ROOT . 'terms-of-use.php';
        
        if( !file_exists($path) )
        {
            require_once BASE_CLASS . 'class-log.php';
            
            LogReport::write('Unable to load terms of use HTML content. File does not exists. Error throw at ' . __FILE__ . ':' . __LINE__);
            
            $this->form_message = $this->lang['TERMS_LOAD_HTML_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-warning';
            return;
        }
        
        // check if file has no content at all.
        if( filesize($path) < 1 )
        {
            $this->html = '';
            return;
        }
        
        if( !$fo = @fopen($path,'r') )
        {
            require_once BASE_CLASS . 'class-log.php';
            
            LogReport::write('Unable to open (fopen) terms of use HTML content. Access denied at ' . __FILE__ . ':' . __LINE__);
            
            $this->form_message = $this->lang['TERMS_LOAD_HTML_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-warning';
            return;
        }
        
        if( !$data = @fread($fo, filesize($path)) )
        {
            @fclose($fo);
            
            require_once BASE_CLASS . 'class-log.php';
            
            LogReport::write('Unable to read (fread) terms of use HTML content. Access denied at ' . __FILE__ . ':' . __LINE__);
            
            $this->form_message = $this->lang['TERMS_LOAD_HTML_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-warning';
            return;
        }
        
        @fclose($fo);
        
        $this->html = stripslashes($data);
    }
    
    /*
     * Public method: get HTML body --------------------------------------------
     * @return string.
     */
    public function getHTMLBody()
    {
        return $this->html;
    }
    
    /*
     * Public method: get form status ------------------------------------------
     * @return bool.
     */
    public function getFormStatus()
    {
        return $this->form_status;
    }
    
    /*
     * Public method: get form message -----------------------------------------
     * @return string.
     */
    public function getFormMessage()
    {
        return $this->form_message;
    }
    
    /*
     * Public method: get form style -------------------------------------------
     * @return string.
     */
    public function getFormStyle()
    {
        return $this->form_style;
    }
}
?>
